function y = fmtone3(t, d, finst, a, ar)
%   ----------------------------------------------------------------
%       
%       Title :     MatLead -SYNTHESIZER-
%       
%       Component : Generate FM Tone
%       
%       Version :   1.0.1 Web Edition
%       Date :      2008.5.22
%       Author :    XIAORING <http://mkgweb.undo.jp>
%       Copyright : (c) 2008 XIAORING. All rights reserved.
%       
%   ----------------------------------------------------------------
%       
%       <Arguments>
%       t =     Time Vector (1, tl*Fs)
%       d =     Time Density ... Length of 1 Sample (sec)
%       finst = instantaneous Frequency (Hz)
%       a =     Harminics Amplifier (ratio) ... a Element of Vector
%       ar =    Resonator Responce (ratio) ... a Element of Vector
%       Fs =    Sampling Frequency (Hz)
%       
%   ----------------------------------------------------------------

b = 2 * pi * finst * d;
ph = cumsum([0 b]);

ph = ph(1 : length(t));

y = a * ar * sin(ph);
