function finst = lfo2(t, f, fw, fv, fa, Fs)
%   ----------------------------------------------------------------
%       
%       Title :     MatLead -SYNTHESIZER-
%       
%       Component : Low Frequency Oscillator
%                   to Make finst
%       
%       Version :   1.0.1 Web Edition
%       Date :      2008.5.22
%       Author :    XIAORING <http://mkgweb.undo.jp>
%       Copyright : (c) 2008 XIAORING. All rights reserved.
%       
%   ----------------------------------------------------------------
%
%       <Arguments>
%       tl =    Length (sec)
%       f =     Center Frequency (Hz)
%       fw =    LFO Amount (ratio) ... Width of Modulation
%       fv =    LFO Rate (ratio) ... Velocity of Modulation
%       fa =    LFO Attack (sec | Vector 1, 2 | col: Amount, Speed)
%       Fs =    Sampling Frequency (Hz)
%       
%       <Required Files>
%           adsr,m
%       
%   ----------------------------------------------------------------


fw = f * fw;
env1 = adsr(t, fa(1), 0, 1, 0, Fs);
env2 = adsr(t, fa(2), 0, 1, 0, Fs);
finst =  f + fw * sin(2 * pi * fv * t .* env2) .* env1;
