function trk = mkTrk2(name, sft, oct, num, den)
%   ----------------------------------------------------------------
%       
%       Title :     MatLead -SYNTHESIZER-
%       
%       Component : Make Trk Structure
%                   to Translate Note f & num/den to tl
%       
%       Version :   1.0.1 Web Edition
%       Date :      2008.5.22
%       Author :    XIAORING <http://mkgweb.undo.jp>
%       Copyright : (c) 2008 XIAORING. All rights reserved.
%       
%   ----------------------------------------------------------------
%
%       <Arguments>
%       name =  Note Name (Char)
%       sft =   Sharp
%                   0 : Natural
%                   1 : Sharp
%       oct =   Octave Number (number)
%       num =   Element of Length (number)
%       den =   Denominator of Length (number)
%       
%   ----------------------------------------------------------------

%-- Key Setting --%
    key = char('c', 'c', 'd', 'd', 'e', 'f', 'f', 'g', 'g', 'a', 'a', 'b', 'r', 't', '#');
    sharp = [0 1 0 1 0 0 1 0 1 0 1 0 0 0 0];
    bpm = 120;

%-- Pitch --%
    r = 2^(1/12);
    c0 = 440 * r^(-9)/16;

%-- Executing --%
    for i = 1 : length(name)
        for j = 1 : length(key)
            if name(i) == key(j) && sft(i) == sharp(j)
                note = (j-1) + 12*oct(i);
                
                if name(i) == 'r';
                    f = 0;
                else
                    f = c0 * r.^note;
                end
                
                if name(i) == 't';
                    f = -1;
                    tl = 0;
                    bpm = den(i);
                elseif name(i) == '#';
                    f = -11;
                    tl = 0;
                else
                    tl = (num(i) * 240) / (den(i) * bpm);
                end

            end
        end

        trk(i).f = f;
        trk(i).d = tl;
    end
