function y = playTrk2(trk, fp, vl, fw, fv, fa, fi, n, wf, ta, td, sl, tr, fei, feInv, tah, tdh, slh, trh, rr, rc, rbw, Fs)
%   ----------------------------------------------------------------
%       
%       Title :     MatLead -SYNTHESIZER-
%       
%       Component : Sound Wav
%                   from Track Structure
%       
%       Version :   1.0.1 Web Edition
%       Date :      2008.5.22
%       Author :    XIAORING <http://mkgweb.undo.jp>
%       Copyright : (c) 2008 XIAORING. All rights reserved.
%       
%   ----------------------------------------------------------------
%
%       <Arguments>
%       trk =   Track (structure)
%       Fs =    Sampling Frequency (Hz)
%       
%       <Required Files>
%           synth4.m
%           waveform.m
%           vco2.m
%           vcoPitch.m
%           vcoMix.m
%           vcf.m
%           rg.m
%           lfo2s.m
%           fmtone3.m
%           vca3.m
%           adsr.m
%       
%   ----------------------------------------------------------------


%-- Initial --%
    y = [];

%-- Executing --%
    for i = 1 : length(trk)
        
        % Note Duration
        if trk(i).f < 0;            % 'v'
            tl = 0;
        else
            tl = trk(i).d;
        end

        % Generate Sound
        if trk(i).f < 0;            % 'v'
            tmp = 0;
        elseif trk(i).f == 0;       % 'r'
            tmp = zeros(1, floor(tl * Fs) + 1);
        else
            tmp = synth4(trk(i).d, trk(i).f, fp, vl, fw, fv, fa, fi, n, wf, ta, td, sl, tr, fei, feInv, tah, tdh, slh, trh, rr, rc, rbw, Fs);
        end

        % Merging
        y = [y tmp];
    end

%-- Sound --%
    % sound(y, Fs);
