%   ----------------------------------------------------------------
%       
%       Title :     MatLead -SYNTHESIZER-
%       
%       Component : Preset Read (LOAD)
%       
%       Version :   1.0.1 Web Edition
%       Date :      2008.5.22
%       Author :    XIAORING <http://mkgweb.undo.jp>
%       Copyright : (c) 2008 XIAORING. All rights reserved.
%       
%   ----------------------------------------------------------------
%
%       <Arguments>
%       mode =  Mode (number (1-2))
%                   1 = Read
%                   2 = Write
%
%       tl =    Time Length (sec)
%       
%       fp =    Pitch (Vector 2, 3 | col: Octave, Transpose, Tune | row: VCO1, VCO2
%       vl =    VCO Mix Level (ratio(0-1) | Vector 1, 2 | col: VCO1, VCO2)
%       
%       fw =    LFO Amount (times)
%       fv =    LFO Rate (Hz)
%       fa =    LFO Attack (sec | Vector 1, 2 | col: Amount, Speed)
%       fi =    LFO In/Out (Bool | Vector: VCO1, VCO2, VCA)
%                   0 = Out (Switch Off)
%                   1 = In (Switch On)
%       
%       cf =    Cutoff Freqency (number: 1-6)
%       wf =    Waveform (number (1-5) | Vector 1, 2 | col: VCO1, VCO2)
%                   1 = Sine
%                   2 = Saw
%                   3 = Square
%                   4 = Triangle
%                   5 = Ramp
%       
%       ta =    Attack Time (sec)
%       td =    Dacay Time (sec)
%       sl =    Sustain Level (ratio(0-1))
%       lr =    Release Time (sec)
%       
%       fei =   Filter Envelope In/Out (Bool | Vector: VCO1, VCO2, VCF)
%                   0 = Out (Switch Off)
%                   1 = In (Switch On)
%       feInv = Filter Envelope Inverse In/Out (Bool | Vector: VCO1, VCO2, VCF)
%                   0 = Out (Switch Off)
%                   1 = In (Switch On)
%       tah =   Attack Time of Filter Env (sec)
%       tdh =   Dacay Time of Filter Env (sec)
%       slh =   Sustain Level of Filter Env (ratio(0-1))
%       lrh =   Release Time of Filter Env (sec)
%       
%       rr =    Resonator Character (ratio)
%       rc =    Center Harmonics of Resonator (number)
%       rbw =   Band Width of Resonator (number)
%       
%       Fs =    Sampling Rate (Hz)
%       
%   ----------------------------------------------------------------


%-- Read --%
    filename = input('ǂݍރvZbg̃t@C͂Ă = ', 's');
    sheet = 1;
    [xVal xChar] = xlsread(filename, sheet);

    tl = xVal(1, 1);
    set(hlEd, 'string', num2str(tl));
    set(hlSl, 'value', tl);

    fp = xVal(2:3, 1:3);
    vl = xVal(4, 1:2);
    set(hfp11, 'string', num2str(fp(1, 1))); set(hfp12, 'string', num2str(fp(1, 2))); set(hfp13, 'string', num2str(fp(1, 3)));
    set(hfp21, 'string', num2str(fp(2, 1))); set(hfp22, 'string', num2str(fp(2, 2))); set(hfp23, 'string', num2str(fp(2, 3)));
    set(hvlEd, 'string', num2str(vl(2)));
    set(hvlSl, 'value', vl(2));

    fw = xVal(5, 1);
    fv = xVal(5, 2);
    fa = xVal(6, 1:2);
    fi = xVal(7, 1:3);
    set(hfwSl, 'value', fw);
    set(hfvSl, 'value', fv);
    set(hfa1Sl, 'value', fa(1)); set(hfa2Sl, 'value', fa(2));
    set(hfiVco1C, 'value', fi(1)); set(hfiVco2C, 'value', fi(2)); set(hfiVcaC, 'value', fi(3));

    wf = xVal(8, 1:2);
    cf = xVal(9, 1);
    if      wf(1) == 1; set(hr11, 'value', 1); set(hr12, 'value', 0); set(hr13, 'value', 0); set(hr14, 'value', 0);
    elseif  wf(1) == 2; set(hr11, 'value', 0); set(hr12, 'value', 1); set(hr13, 'value', 0); set(hr14, 'value', 0);
    elseif  wf(1) == 3; set(hr11, 'value', 0); set(hr12, 'value', 0); set(hr13, 'value', 1); set(hr14, 'value', 0);
    elseif  wf(1) == 4; set(hr11, 'value', 0); set(hr12, 'value', 0); set(hr13, 'value', 0); set(hr14, 'value', 1);
    end
    if      wf(2) == 1; set(hr21, 'value', 1); set(hr22, 'value', 0); set(hr23, 'value', 0); set(hr24, 'value', 0);
    elseif  wf(2) == 2; set(hr21, 'value', 0); set(hr22, 'value', 1); set(hr23, 'value', 0); set(hr24, 'value', 0);
    elseif  wf(2) == 3; set(hr21, 'value', 0); set(hr22, 'value', 0); set(hr23, 'value', 1); set(hr24, 'value', 0);
    elseif  wf(2) == 4; set(hr21, 'value', 0); set(hr22, 'value', 0); set(hr23, 'value', 0); set(hr24, 'value', 1);
    end
    set(hnSl, 'value', cf);


    ta = xVal(10, 1);
    td = xVal(10, 2);
    sl = xVal(10, 3);
    tr = xVal(10, 4);
    set(haSl, 'value', ta);
    set(hdSl, 'value', td);
    set(hsSl, 'value', sl);
    set(hrSl, 'value', tr);

    fei = xVal(11, 1:3);
    feInv = xVal(12, 1:3);
    tah = xVal(13, 1);
    tdh = xVal(13, 2);
    slh = xVal(13, 3);
    trh = xVal(13, 4);
    set(hfeiVco1Sl, 'value', fei(1)); set(hfeiVco2Sl, 'value', fei(2)); set(hfeiVcfC, 'value', fei(3));
    set(hfeInvVco1C, 'value', feInv(1)); set(hfeInvVco2C, 'value', feInv(2));
    set(hahSl, 'value', tah);
    set(hdhSl, 'value', tdh);
    set(hshSl, 'value', slh);
    set(hrhSl, 'value', trh);

    rr = xVal(14, 1);
    rc = xVal(14, 2);
    rbw = xVal(14, 3);
    set(hrrSl, 'value', rr);
    set(hrcSl, 'value', rc);
    set(hrbwSl, 'value', rbw);

    Fs = xVal(15, 1);
   