%   ----------------------------------------------------------------
%       
%       Title :     MatLead -SYNTHESIZER-
%       
%       Component : Preset Write (SAVE)
%       
%       Version :   1.0.1 Web Edition
%       Date :      2008.5.22
%       Author :    XIAORING <http://mkgweb.undo.jp>
%       Copyright : (c) 2008 XIAORING. All rights reserved.
%       
%   ----------------------------------------------------------------
%
%       <Arguments>
%       mode =  Mode (number (1-2))
%                   1 = Read
%                   2 = Write
%
%       tl =    Time Length (sec)
%       
%       fp =    Pitch (Vector 2, 3 | col: Octave, Transpose, Tune | row: VCO1, VCO2
%       vl =    VCO Mix Level (ratio(0-1) | Vector 1, 2 | col: VCO1, VCO2)
%       
%       fw =    LFO Amount (times)
%       fv =    LFO Rate (Hz)
%       fa =    LFO Attack (sec | Vector 1, 2 | col: Amount, Speed)
%       fi =    LFO In/Out (Bool | Vector: VCO1, VCO2, VCA)
%                   0 = Out (Switch Off)
%                   1 = In (Switch On)
%       
%       cf =    Cutoff Freqency (number: 1-6)
%       wf =    Waveform (number (1-5) | Vector 1, 2 | col: VCO1, VCO2)
%                   1 = Sine
%                   2 = Saw
%                   3 = Square
%                   4 = Triangle
%                   5 = Ramp
%       
%       ta =    Attack Time (sec)
%       td =    Dacay Time (sec)
%       sl =    Sustain Level (ratio(0-1))
%       lr =    Release Time (sec)
%       
%       fei =   Filter Envelope In/Out (Bool | Vector: VCO1, VCO2, VCF)
%                   0 = Out (Switch Off)
%                   1 = In (Switch On)
%       feInv = Filter Envelope Inverse In/Out (Bool | Vector: VCO1, VCO2, VCF)
%                   0 = Out (Switch Off)
%                   1 = In (Switch On)
%       tah =   Attack Time of Filter Env (sec)
%       tdh =   Dacay Time of Filter Env (sec)
%       slh =   Sustain Level of Filter Env (ratio(0-1))
%       lrh =   Release Time of Filter Env (sec)
%       
%       rr =    Resonator Character (ratio)
%       rc =    Center Harmonics of Resonator (number)
%       rbw =   Band Width of Resonator (number)
%       
%       Fs =    Sampling Rate (Hz)
%
%   ----------------------------------------------------------------


%-- Write --%
    presetMat = [   tl 0 0 0; ...
                    fp(1, 1) fp(1, 2) fp(1, 3) 0; ...
                    fp(2, 1) fp(2, 2) fp(2, 3) 0; ...
                    vl(1) vl(2) 0 0; ...
                    fw fv 0 0; ...
                    fa(1) fa(2) 0 0; ...
                    fi(1) fi(2) fi(3) 0; ...
                    wf(1), wf(2) 0 0; ...
                    cf 0 0 0; ...
                    ta td sl tr; ...
                    fei(1), fei(2), fei(3) 0; ...
                    feInv(1), feInv(2), feInv(3) 0; ...
                    tah tdh slh trh; ...
                    rr rc rbw 0; ...
                    Fs 0 0 0 ...
                ];

    filename = input('ۑvZbg̃t@C͂Ă = ', 's');
    xlswrite(filename, presetMat);
   