function trk = trackread2(filename, sheet)
%   ----------------------------------------------------------------
%       
%       Title :     MatLead -SYNTHESIZER-
%       
%       Component : Track Read
%                   from MS-Excel Sheet
%                   to Track Structure
%       
%       Version :   1.0.1 Web Edition
%       Date :      2008.5.22
%       Author :    XIAORING <http://mkgweb.undo.jp>
%       Copyright : (c) 2008 XIAORING. All rights reserved.
%       
%   ----------------------------------------------------------------
%
%       <Arguments>
%       filename =  MS-Excel File Name (string)
%       sheet =     Sheet Name (string)
%       
%       <Required Files>
%           mkTrk2.m
%       
%       
%       <Excel Track Matrix>
%       
%           [A]     |   [B]     [C]     [D]     [E]
%         ----------+-----------------------------------
%           name    |   sft     oct     num     den
%           .       |   .       .       .       .
%           .       |   .       .       .       .
%         ----------+-----------------------------------
%           xChar   |               xVal
%       
%   ----------------------------------------------------------------


[xVal xChar] = xlsread(filename, sheet);

name = char(xChar)';
sft = xVal(:, 1)';
oct = xVal(:, 2)';
num = xVal(:, 3)';
den = xVal(:, 4)';

trk = mkTrk2(name, sft, oct, num, den);
