%   ----------------------------------------------------------------
%       
%       Title :     MatLead -SYNTHESIZER-
%       
%       Component : User Interface of Keyboard Section
%       
%       Version :   1.0.1 Web Edition
%       Date :      2008.5.22
%       Author :    XIAORING <http://mkgweb.undo.jp>
%       Copyright : (c) 2008 XIAORING. All rights reserved.
%       
%   ----------------------------------------------------------------


%-- Keyboard --%
    note = char('C', 'C#', 'D', 'D#', 'E', 'F', 'F#', 'G', 'G#', 'A', 'A#', 'B', 'C');

    % f[1, 13] = Frequency C4 to C5
    for i = 1 : 12
        f(i) = 27.5 * ( 2^( (i-10) /12) );
    end
    
    hk = [];

    % White Key
    j = 0;
    for ii = 1 : 7
        for i = [1 3 5 6 8 10 12]
            % Callback
            ck = [ ...
                'fi;y = synth4(tl, f(' (num2str(i)) ')*2^' (num2str(ii)) ', fp, vl, fw, fv, fa, fi, n, wf, ta, td, sl, tr, fei, feInv, tah, tdh, slh, trh, rr, rc, rbw, Fs);' ...
                'sound(y, Fs);' ...
            ];

            % UI
            hk(i) = uicontrol( ...
                'style', 'pushbutton', ...
                'units', 'pixels', ...
                'position', [20+15*j 20 15 70], ...
                'fore', 'k', ...
                'back', 'w', ...
                'callback', ck ...
            );

            j = j + 1;
        end
    end

    % Black Key
    j = 0;
    for ii = 1 : 7
        for i = [2 4 7 9 11]
            % Callback
            ck = [ ...
                'y = synth4(tl, f(' (num2str(i)) ')*2^' (num2str(ii)) ', fp, vl, fw, fv, fa, fi, n, wf, ta, td, sl, tr, fei, feInv, tah, tdh, slh, trh, rr, rc, rbw, Fs);' ...
                'sound(y, Fs);' ...
            ];

            % UI
            hk(i) = uicontrol( ...
                'style', 'pushbutton', ...
                'units', 'pixels', ...
                'position', [29+15*j 50 12 40], ...
                'fore', 'w', ...
                'back', 'k', ...
                'callback', ck ...
            );

            if mod(i, 12) == 4
                j = j + 2;
            elseif mod(i, 12) == 11
                j = j + 2;
            else
                j = j + 1;
            end
        end
    end
