%   ----------------------------------------------------------------
%       
%       Title :     MatLead -SYNTHESIZER-
%       
%       Component : User Interface of LFO Section
%       
%       Version :   1.0.1 Web Edition
%       Date :      2008.5.22
%       Author :    XIAORING <http://mkgweb.undo.jp>
%       Copyright : (c) 2008 XIAORING. All rights reserved.
%       
%   ----------------------------------------------------------------


%-- GUI Panel LFO --%
    hpLfo = uipanel(...
        'units', 'pixels', ...
        'position', [235 110 530 70], ...
        'back', clrPanel, ...
        'fore', clrLabel, ...
        'title', 'LFO' ...
    );

    fwMin = 0.0;    % Max fw
    fwMax = 1.0;    % Min fw
    fvMin = 0.01;   % Max fv
    fvMax = 50.0;   % Min fv
    fa1Min = 0.00;   % Max fa
    fa1Max = 1.00;   % Min fa
    fa2Min = 0.00;   % Max fa
    fa2Max = 1.00;   % Min fa
    fiMin = 0;      % Min LFO IN
    fiMax = 1;      % Max LFO IN

    % Callback
    cfwSl = 'fw = get(hfwSl,''value'');';   % fw Slider
    cfvSl = 'fv = get(hfvSl,''value'');';   % fv Slider
    cfa1Sl = 'fa(1) = get(hfa1Sl,''value'');';   % fa1 Slider
    cfa2Sl = 'fa(2) = get(hfa2Sl,''value'');';   % fa2 Slider
    cfiVco1C = 'fi(1) = get(hfiVco1C,''value'');';     % fi Checkbox
    cfiVco2C = 'fi(2) = get(hfiVco2C,''value'');';
    cfiVcaC = 'fi(3) = get(hfiVcaC,''value'');';

    % Make UI
    % fw
    hfwSl = uicontrol( ...                   % fw Slider
        'style', 'slider', ...
        'parent', hpLfo, ...
        'units', 'pixels', ...
        'position', [65 10+20*1 115 15], ...
        'value', fw, ...
        'min', fwMin, ...
        'max', fwMax, ...
        'back', clrSl, ...
        'fore', clrLabel, ...
        'callback', cfwSl ...
    );
    hfwLabel = uicontrol( ...
        'style', 'text', ...
        'parent', hpLfo, ...
        'units', 'pixels', ...
        'position', [5 10+20*1 60 15], ...
        'back', clrPanel, ...
        'fore', clrLabel, ...
        'string', 'AMOUNT :' ...
    );

    % fv
    hfvSl = uicontrol( ...                   % fv Slider
        'style', 'slider', ...
        'parent', hpLfo, ...
        'units', 'pixels', ...
        'position', [65 10+20*0 115 15], ...
        'value', fv, ...
        'min', fvMin, ...
        'max', fvMax, ...
        'back', clrSl, ...
        'fore', clrLabel, ...
        'callback', cfvSl ...
    );
    hfvLabel = uicontrol( ...
        'style', 'text', ...
        'parent', hpLfo, ...
        'units', 'pixels', ...
        'position', [5 10+20*0 60 15], ...
        'back', clrPanel, ...
        'fore', clrLabel, ...
        'string', 'SPEED :' ...
    );
    
    % fa(1)
    hfa1Sl = uicontrol( ...                   % fa Slider
        'style', 'slider', ...
        'parent', hpLfo, ...
        'units', 'pixels', ...
        'position', [65+175 10+20*1 95 15], ...
        'value', fa(1), ...
        'min', fa1Min, ...
        'max', fa1Max, ...
        'back', clrSl, ...
        'fore', clrLabel, ...
        'callback', cfa1Sl ...
    );
    hfa1Label = uicontrol( ...
        'style', 'text', ...
        'parent', hpLfo, ...
        'units', 'pixels', ...
        'position', [5+175 10+20*1 60 15], ...
        'back', clrPanel, ...
        'fore', clrLabel, ...
        'string', 'ATTACK :' ...
    );
    
    % fa(2)
    hfa2Sl = uicontrol( ...                   % fa Slider
        'style', 'slider', ...
        'parent', hpLfo, ...
        'units', 'pixels', ...
        'position', [65+175 10+20*0 95 15], ...
        'value', fa(2), ...
        'min', fa2Min, ...
        'max', fa2Max, ...
        'back', clrSl, ...
        'fore', clrLabel, ...
        'callback', cfa2Sl ...
    );
    hfa2Label = uicontrol( ...
        'style', 'text', ...
        'parent', hpLfo, ...
        'units', 'pixels', ...
        'position', [5+175 10+20*0 60 15], ...
        'back', clrPanel, ...
        'fore', clrLabel, ...
        'string', 'ACCEL :' ...
    );
    
    % fi Destination
    % Panel
    hpLfoFi = uipanel(...
        'parent', hpLfo, ...
        'units', 'pixels', ...
        'position', [345 10 170 40], ...
        'back', clrPanel, ...
        'fore', clrLabel, ...
        'title', 'Destination' ...
    );
    
    % VCO1
    hfiVco1C = uicontrol( ...
        'style', 'checkbox', ...
        'parent', hpLfoFi, ...
        'units', 'pixels', ...
        'position', [5+55*0 5 50 20], ...
        'max', fiMax, ...
        'min', fiMin, ...
        'back', clrPanel, ...
        'fore', clrLabel, ...
        'string', 'VCO1', ...
        'callback', cfiVco1C ...
    );
    
    % VCO2
    hfiVco2C = uicontrol( ...
        'style', 'checkbox', ...
        'parent', hpLfoFi, ...
        'units', 'pixels', ...
        'position', [5+55*1 5 50 20], ...
        'max', fiMax, ...
        'min', fiMin, ...
        'back', clrPanel, ...
        'fore', clrLabel, ...
        'string', 'VCO2', ...
        'callback', cfiVco2C ...
    );
    
    % VCA
    hfiVcaC = uicontrol( ...
        'style', 'checkbox', ...
        'parent', hpLfoFi, ...
        'units', 'pixels', ...
        'position', [5+55*2 5 50 20], ...
        'max', fiMax, ...
        'min', fiMin, ...
        'back', clrPanel, ...
        'fore', clrLabel, ...
        'string', 'VCA', ...
        'callback', cfiVcaC ...
    );
