%   ----------------------------------------------------------------
%       
%       Title :     MatLead -SYNTHESIZER-
%       
%       Component : User Interface of VCA Section
%       
%       Version :   1.0.1 Web Edition
%       Date :      2008.5.22
%       Author :    XIAORING <http://mkgweb.undo.jp>
%       Copyright : (c) 2008 XIAORING. All rights reserved.
%       
%   ----------------------------------------------------------------


%-- GUI Panel VCA --%
    hpVca = uipanel(...
        'units', 'pixels', ...
        'position', [450 250 200 220], ...
        'back', clrPanel, ...
        'fore', clrLabel, ...
        'title', 'VCA' ...
    );

    % A.EG
    hpAeg = uipanel(...
        'parent', hpVca, ...
        'units', 'pixels', ...
        'position', [10 90 175 110], ...
        'back', clrDiv3, ...
        'fore', clrLabel, ...
        'title', 'AMP EG' ...
    );

%-- VCA ADSR --%
    tadrMin = 0.0;      % Max A/D/R
    tadrMax = 1.0;      % Min A/D/R
    tsMin = 0.0;        % Max S
    tsMax = 1.0;        % Min S

    % Callback
    caSl = 'ta = get(haSl,''value'');';   % A Slider
    cdSl = 'td = get(hdSl,''value'');';   % D Slider
    csSl = 'sl = get(hsSl,''value'');';   % S Slider
    crSl = 'tr = get(hrSl,''value'');';   % R Slider

    % Make UI
    % A
    haSl = uicontrol( ...                   % A Slider
        'style', 'slider', ...
        'parent', hpAeg, ...
        'units', 'pixels', ...
        'position', [30 10+20*3 115 15], ...
        'value', ta, ...
        'min', tadrMin, ...
        'max', tadrMax, ...
        'back', clrSl, ...
        'fore', clrLabel, ...
        'callback', caSl ...
    );
    haLabel = uicontrol( ...
        'style', 'text', ...
        'parent', hpAeg, ...
        'units', 'pixels', ...
        'position', [5 10+20*3 20 15], ...
        'string', 'A :', ...
        'back', clrDiv3, ...
        'fore', clrLabel ...
    );

    % D
    hdSl = uicontrol( ...                   % D Slider
        'style', 'slider', ...
        'parent', hpAeg, ...
        'units', 'pixels', ...
        'position', [30 10+20*2 115 15], ...
        'value', td, ...
        'min', tadrMin, ...
        'max', tadrMax, ...
        'back', clrSl, ...
        'fore', clrLabel, ...
        'callback', cdSl ...
    );
    hdLabel = uicontrol( ...
        'style', 'text', ...
        'parent', hpAeg, ...
        'units', 'pixels', ...
        'position', [5 10+20*2 20 15], ...
        'string', 'D :', ...
        'back', clrDiv3, ...
        'fore', clrLabel ...
    );

    % S
    hsSl = uicontrol( ...                   % S Slider
        'style', 'slider', ...
        'parent', hpAeg, ...
        'units', 'pixels', ...
        'position', [30 10+20*1 115 15], ...
        'value', sl, ...
        'min', tsMin, ...
        'max', tsMax, ...
        'back', clrSl, ...
        'fore', clrLabel, ...
        'callback', csSl ...
    );
    hsLabel = uicontrol( ...
        'style', 'text', ...
        'parent', hpAeg, ...
        'units', 'pixels', ...
        'position', [5 10+20*1 20 15], ...
        'string', 'S :', ...
        'back', clrDiv3, ...
        'fore', clrLabel ...
    );

    % R
    hrSl = uicontrol( ...                   % R Slider
        'style', 'slider', ...
        'parent', hpAeg, ...
        'units', 'pixels', ...
        'position', [30 10+20*0 115 15], ...
        'value', tr, ...
        'min', tadrMin, ...
        'max', tadrMax, ...
        'back', clrSl, ...
        'fore', clrLabel, ...
        'callback', crSl ...
    );
    hrLabel = uicontrol( ...
        'style', 'text', ...
        'parent', hpAeg, ...
        'units', 'pixels', ...
        'position', [5 10+20*0 20 15], ...
        'string', 'R :', ...
        'back', clrDiv3, ...
        'fore', clrLabel ...
    );


%-- Length --%
    tlMin = 0.1;        % Max Length
    tlMax = 1.0;        % Min Length

    % Callback
    clEd = [ ...                            % Editbox
        'tlStr = get(hlEd, ''string'');' ...      % Get Value
        'tl = str2num(tlStr); ' ...
        'set(hlsl,''value'',tl);' ...             % Set Slider
    ];
    clSl = [ ...                            % Slider
        'tl = get(hlSl,''value'');' ...           % Get Value
        'set(hlEd,''string'',num2str(tl));' ...   % Set Editbox
    ];


    % Make UI
    hlEd = uicontrol( ...                    % Editbox
        'style', 'edit', ...
        'parent', hpVca, ...
        'units', 'pixels', ...
        'position', [70 50 70 25], ...
        'string', num2str(tl), ...
        'callback', clEd, ...
        'back', clrTextBack, ...
        'fore', clrTextFore ...
    );
    hlSl = uicontrol( ...                    % Slider
        'style', 'slider', ...
        'parent', hpVca, ...
        'units', 'pixels', ...
        'position', [15 15 170 25], ...
        'value', tl, ...
        'min', tlMin, ...
        'max', tlMax, ...
        'back', clrSl', ...
        'fore', clrLabel, ...
        'callback', clSl ...
    );
    hlLabel = uicontrol( ...
        'style', 'text', ...
        'parent', hpVca, ...
        'units', 'pixels', ...
        'position', [10 50 60 20], ...
        'string', 'LENGTH :', ...
        'back', clrPanel, ...
        'fore', clrLabel ...
    );
