%   ----------------------------------------------------------------
%       
%       Title :     MatLead -SYNTHESIZER-
%       
%       Component : User Interface of VCF Section
%       
%       Version :   1.0.1 Web Edition
%       Date :      2008.5.22
%       Author :    XIAORING <http://mkgweb.undo.jp>
%       Copyright : (c) 2008 XIAORING. All rights reserved.
%       
%   ----------------------------------------------------------------


%-- GUI Panel VCF --%
    hpVcf = uipanel(...
        'units', 'pixels', ...
        'position', [235 190 200 280], ...
        'back', clrPanel, ...
        'fore', clrLabel, ...
        'title', 'VCF' ...
    );

%-- VCF CUTOFF --%
    nMin = 0;      % Max Number of Harmonics
    nMax = 6;      % Min Number of Harmonics

    % Callback
    cnSl = 'cf = get(hnSl,''value''); n = floor(2^cf);';   % Cutoff Slider

    % Make UI
    % Cutoff
    hnSl = uicontrol( ...                   % Cutoff Slider
        'style', 'slider', ...
        'parent', hpVcf, ...
        'units', 'pixels', ...
        'position', [70 245+20*0 115 15], ...
        'value', cf, ...
        'min', nMin, ...
        'max', nMax, ...
        'back', clrSl, ...
        'fore', clrLabel, ...
        'callback', cnSl ...
    );
    hnLabel = uicontrol( ...
        'style', 'text', ...
        'parent', hpVcf, ...
        'units', 'pixels', ...
        'position', [5 245+20*0 60 15], ...
        'back', clrPanel, ...
        'fore', clrLabel, ...
        'string', 'CUTOFF :' ...
    );

%-- VCF ADSR --%
    % Panel
    hpFeg = uipanel(...
        'parent', hpVcf, ...
        'units', 'pixels', ...
        'position', [10 105 175 130], ...
        'back', clrDiv2, ...
        'fore', clrLabel, ...
        'title', 'FILTER EG' ...
    );

    tadrhMin = 0.0;      % Max A/D/R
    tadrhMax = 1.0;      % Min A/D/R
    tshMin = 0.0;        % Max S
    tshMax = 1.0;        % Min S
    feiMin = 0;          % Max fei
    feiMax = 1;          % Min fei

    % Callback
    cahSl = 'tah = get(hahSl,''value'');';   % A Slider
    cdhSl = 'tdh = get(hdhSl,''value'');';   % D Slider
    cshSl = 'slh = get(hshSl,''value'');';   % S Slider
    crhSl = 'trh = get(hrhSl,''value'');';   % R Slider
    cfeiVcfC = 'fei(3) = get(hfeiVcfC,''value'');';     % fei Checkbox

    % Make UI
    % A
    hahSl = uicontrol( ...                   % A Slider
        'style', 'slider', ...
        'parent', hpFeg, ...
        'units', 'pixels', ...
        'position', [30 30+20*3 115 15], ...
        'value', tah, ...
        'min', tadrhMin, ...
        'max', tadrhMax, ...
        'back', clrSl, ...
        'fore', clrLabel, ...
        'callback', cahSl ...
    );
    hahLabel = uicontrol( ...
        'style', 'text', ...
        'parent', hpFeg, ...
        'units', 'pixels', ...
        'position', [5 30+20*3 20 15], ...
        'string', 'A :', ...
        'back', clrDiv2, ...
        'fore', clrLabel ...
    );

    % D
    hdhSl = uicontrol( ...                   % D Slider
        'style', 'slider', ...
        'parent', hpFeg, ...
        'units', 'pixels', ...
        'position', [30 30+20*2 115 15], ...
        'value', tdh, ...
        'min', tadrhMin, ...
        'max', tadrhMax, ...
        'back', clrSl, ...
        'fore', clrLabel, ...
        'callback', cdhSl ...
    );
    hdhLabel = uicontrol( ...
        'style', 'text', ...
        'parent', hpFeg, ...
        'units', 'pixels', ...
        'position', [5 30+20*2 20 15], ...
        'string', 'D :', ...
        'back', clrDiv2, ...
        'fore', clrLabel ...
    );

    % S
    hshSl = uicontrol( ...                   % S Slider
        'style', 'slider', ...
        'parent', hpFeg, ...
        'units', 'pixels', ...
        'position', [30 30+20*1 115 15], ...
        'value', slh, ...
        'min', tshMin, ...
        'max', tshMax, ...
        'back', clrSl, ...
        'fore', clrLabel, ...
        'callback', cshSl ...
    );
    hshLabel = uicontrol( ...
        'style', 'text', ...
        'parent', hpFeg, ...
        'units', 'pixels', ...
        'position', [5 30+20*1 20 15], ...
        'string', 'S :', ...
        'back', clrDiv2, ...
        'fore', clrLabel ...
    );

    % R
    hrhSl = uicontrol( ...                   % R Slider
        'style', 'slider', ...
        'parent', hpFeg, ...
        'units', 'pixels', ...
        'position', [30 30+20*0 115 15], ...
        'value', trh, ...
        'min', tadrhMin, ...
        'max', tadrhMax, ...
        'back', clrSl, ...
        'fore', clrLabel, ...
        'callback', crhSl ...
    );
    hrhLabel = uicontrol( ...
        'style', 'text', ...
        'parent', hpFeg, ...
        'units', 'pixels', ...
        'position', [5 30+20*0 20 15], ...
        'string', 'R :', ...
        'back', clrDiv2, ...
        'fore', clrLabel ...
    );
    
    % IN
    hfeiVcfC = uicontrol( ...
        'style', 'checkbox', ...
        'parent', hpFeg, ...
        'units', 'pixels', ...
        'position', [130 5 35 20], ...
        'value', fei(3), ...
        'max', feiMax, ...
        'min', feiMin, ...
        'string', 'IN', ...
        'back', clrDiv2, ...
        'fore', clrLabel, ...
        'callback', cfeiVcfC ...
    );


%-- VCF RG --%
    % Panel
    hpRg = uipanel(...
        'parent', hpVcf, ...
        'units', 'pixels', ...
        'position', [10 10 175 90], ...
        'back', clrDiv2, ...
        'fore', clrLabel, ...
        'title', 'RESONANCE' ...
    );

    rrMin = 1.0;      % Max rr
    rrMax = 10.0;      % Min rr
    rcMin = 1.0;        % Max rc
    rcMax = 20.0;        % Min rc
    rbwMin = 0.0;        % Max rbw
    rbwMax = 5.0;        % Min rbw

    % Callback
    crrSl = 'rr = get(hrrSl,''value'');';   % rr Slider
    crcSl = 'rc = round(get(hrcSl,''value''));';   % rc Slider
    crbwSl = 'rbw = round(get(hrbwSl,''value''));';   % rbw Slider

    % Make UI
    % rr
    hrrSl = uicontrol( ...                   % rr Slider
        'style', 'slider', ...
        'parent', hpRg, ...
        'units', 'pixels', ...
        'position', [30 10+20*2 115 15], ...
        'value', rr, ...
        'min', rrMin, ...
        'max', rrMax, ...
        'back', clrSl, ...
        'fore', clrLabel, ...
        'callback', crrSl ...
    );
    hrrLabel = uicontrol( ...
        'style', 'text', ...
        'parent', hpRg, ...
        'units', 'pixels', ...
        'position', [5 10+20*2 20 15], ...
        'string', 'R :', ...
        'back', clrDiv2, ...
        'fore', clrLabel ...
    );

    % rc
    hrcSl = uicontrol( ...                   % rc Slider
        'style', 'slider', ...
        'parent', hpRg, ...
        'units', 'pixels', ...
        'position', [30 10+20*1 115 15], ...
        'value', rc, ...
        'min', rcMin, ...
        'max', rcMax, ...
        'back', clrSl, ...
        'fore', clrLabel, ...
        'callback', crcSl ...
    );
    hrcLabel = uicontrol( ...
        'style', 'text', ...
        'parent', hpRg, ...
        'units', 'pixels', ...
        'position', [5 10+20*1 20 15], ...
        'string', 'C :', ...
        'back', clrDiv2, ...
        'fore', clrLabel ...
    );

    % rbw
    hrbwSl = uicontrol( ...                   % rbw Slider
        'style', 'slider', ...
        'parent', hpRg, ...
        'units', 'pixels', ...
        'position', [30 10+20*0 115 15], ...
        'value', rbw, ...
        'min', rbwMin, ...
        'max', rbwMax, ...
        'back', clrSl, ...
        'fore', clrLabel, ...
        'callback', crbwSl ...
    );
    hrbwLabel = uicontrol( ...
        'style', 'text', ...
        'parent', hpRg, ...
        'units', 'pixels', ...
        'position', [5 10+20*0 20 15], ...
        'string', 'W :', ...
        'back', clrDiv2, ...
        'fore', clrLabel ...
    );
