%   ----------------------------------------------------------------
%       
%       Title :     MatLead -SYNTHESIZER-
%       
%       Component : User Interface of VCO Section
%       
%       Version :   1.0.1 Web Edition
%       Date :      2008.5.22
%       Author :    XIAORING <http://mkgweb.undo.jp>
%       Copyright : (c) 2008 XIAORING. All rights reserved.
%       
%   ----------------------------------------------------------------


%-- GUI Panel VCO --%
    hpVco = uipanel(...
        'units', 'pixels', ...
        'position', [20 110 200 360], ...
        'back', clrPanel, ...
        'fore', clrLabel, ...
        'title', 'VCO' ...
    );

%-- Waveform 1 --%
    hpWf1 = uipanel( ...
        'parent', hpVco, ...
        'units', 'pixels', ...
        'position', [10 240 175 100], ...
        'back', clrDiv1, ...
        'fore', clrLabel, ...
        'title', 'VCO1' ...
    );
    
    cr11 = [ ...
        'wf(1) = 1;' ...
        'set(hr12,''value'',0);' ...
        'set(hr13,''value'',0);' ...
        'set(hr14,''value'',0);' ...
    ];
    hr11 = uicontrol( ...
        'style', 'radiobutton', ...
        'parent', hpWf1, ...
        'units', 'pixels', ...
        'position', [5 5+20*3 70 20], ...
        'string', '` SIN', ...
        'back', clrDiv1, ...
        'fore', clrLabel, ...
        'callback', cr11 ...
    );

    cr12 = [ ...
        'wf(1) = 2;' ...
        'set(hr11, ''value'', 0);' ...
        'set(hr13, ''value'', 0);' ...
        'set(hr14,''value'',0);' ...
    ];
    hr12 = uicontrol( ...
        'style', 'radiobutton', ...
        'parent', hpWf1, ...
        'units', 'pixels', ...
        'position', [5 5+20*2 70 20], ...
        'string', '// SAW', ...
        'value', 1, ...
        'back', clrDiv1, ...
        'fore', clrLabel, ...
        'callback', cr12 ...
    );

    cr13 = [ ...
        'wf(1) = 3;' ...
        'set(hr11, ''value'', 0);' ...
        'set(hr12, ''value'', 0);' ...
        'set(hr14,''value'',0);' ...
    ];
    hr13 = uicontrol( ...
        'style', 'radiobutton', ...
        'parent', hpWf1, ...
        'units', 'pixels', ...
        'position', [5 5+20*1 70 20], ...
        'string', ' SQR', ...
        'back', clrDiv1, ...
        'fore', clrLabel, ...
        'callback', cr13 ...
    );

    cr14 = [ ...
        'wf(1) = 4;' ...
        'set(hr11, ''value'', 0);' ...
        'set(hr12, ''value'', 0);' ...
        'set(hr13,''value'',0);' ...
    ];
    hr14 = uicontrol( ...
        'style', 'radiobutton', ...
        'parent', hpWf1, ...
        'units', 'pixels', ...
        'position', [5 5+20*0 70 20], ...
        'string', ' TRI', ...
        'back', clrDiv1, ...
        'fore', clrLabel, ...
        'callback', cr14 ...
    );


%-- Waveform 2 --%
    hpWf2 = uipanel( ...
        'parent', hpVco, ...
        'units', 'pixels', ...
        'position', [10 135 175 100], ...
        'back', clrDiv1, ...
        'fore', clrLabel, ...
        'title', 'VCO2' ...
    );
    
    cr21 = [ ...
        'wf(2) = 1;' ...
        'set(hr22,''value'',0);' ...
        'set(hr23,''value'',0);' ...
        'set(hr24,''value'',0);' ...
    ];
    hr21 = uicontrol( ...
        'style', 'radiobutton', ...
        'parent', hpWf2, ...
        'units', 'pixels', ...
        'position', [5 5+20*3 70 20], ...
        'string', '` SIN', ...
        'back', clrDiv1, ...
        'fore', clrLabel, ...
        'callback', cr21 ...
    );

    cr22 = [ ...
        'wf(2) = 2;' ...
        'set(hr21, ''value'', 0);' ...
        'set(hr23, ''value'', 0);' ...
        'set(hr24,''value'',0);' ...
    ];
    hr22 = uicontrol( ...
        'style', 'radiobutton', ...
        'parent', hpWf2, ...
        'units', 'pixels', ...
        'position', [5 5+20*2 70 20], ...
        'string', '// SAW', ...
        'value', 1, ...
        'back', clrDiv1, ...
        'fore', clrLabel, ...
        'callback', cr22 ...
    );

    cr23 = [ ...
        'wf(2) = 3;' ...
        'set(hr21, ''value'', 0);' ...
        'set(hr22, ''value'', 0);' ...
        'set(hr24,''value'',0);' ...
    ];
    hr23 = uicontrol( ...
        'style', 'radiobutton', ...
        'parent', hpWf2, ...
        'units', 'pixels', ...
        'position', [5 5+20*1 70 20], ...
        'string', ' SQR', ...
        'back', clrDiv1, ...
        'fore', clrLabel, ...
        'callback', cr23 ...
    );

    cr24 = [ ...
        'wf(2) = 4;' ...
        'set(hr21, ''value'', 0);' ...
        'set(hr22, ''value'', 0);' ...
        'set(hr23,''value'',0);' ...
    ];
    hr24 = uicontrol( ...
        'style', 'radiobutton', ...
        'parent', hpWf2, ...
        'units', 'pixels', ...
        'position', [5 5+20*0 70 20], ...
        'string', ' TRI', ...
        'back', clrDiv1, ...
        'fore', clrLabel, ...
        'callback', cr24 ...
    );


%-- Pitch --%
    % Callback
    cfp11 = 'fp(1, 1) = str2num(get(hfp11, ''string''));';
    cfp12 = 'fp(1, 2) = str2num(get(hfp12, ''string''));';
    cfp13 = 'fp(1, 3) = str2num(get(hfp13, ''string''));';
    cfp21 = 'fp(2, 1) = str2num(get(hfp21, ''string''));';
    cfp22 = 'fp(2, 2) = str2num(get(hfp22, ''string''));';
    cfp23 = 'fp(2, 3) = str2num(get(hfp23, ''string''));';


    % Make UI
    % VCO1
    hfp11 = uicontrol( ...                    % Octave
        'style', 'edit', ...
        'parent', hpWf1, ...
        'units', 'pixels', ...
        'position', [125 10+25*2 40 20], ...
        'string', num2str(fp(1, 1)), ...
        'callback', cfp11, ...
        'back', clrTextBack, ...
        'fore', clrTextFore ...
    );
    hfp11Label = uicontrol( ...
        'style', 'text', ...
        'parent', hpWf1, ...
        'units', 'pixels', ...
        'position', [80 5+25*2 40 20], ...
        'string', 'OCT :', ...
        'fore', clrLabel, ...
        'back', clrDiv1 ...
    );

    hfp12 = uicontrol( ...                    % Transpose
        'style', 'edit', ...
        'parent', hpWf1, ...
        'units', 'pixels', ...
        'position', [125 10+25*1 40 20], ...
        'string', num2str(fp(1, 2)), ...
        'callback', cfp12, ...
        'back', clrTextBack, ...
        'fore', clrTextFore ...
    );
    hfp12Label = uicontrol( ...
        'style', 'text', ...
        'parent', hpWf1, ...
        'units', 'pixels', ...
        'position', [80 5+25*1+3 40 25], ...
        'string', 'TRANSPOSE :', ...
        'fore', clrLabel, ...
        'back', clrDiv1 ...
    );

    hfp13 = uicontrol( ...                    % Tune
        'style', 'edit', ...
        'parent', hpWf1, ...
        'units', 'pixels', ...
        'position', [125 10+25*0 40 20], ...
        'string', num2str(fp(1, 3)), ...
        'callback', cfp13, ...
        'back', clrTextBack, ...
        'fore', clrTextFore ...
    );
    hfp13Label = uicontrol( ...
        'style', 'text', ...
        'parent', hpWf1, ...
        'units', 'pixels', ...
        'position', [80 5+25*0 40 20], ...
        'string', 'TUNE :', ...
        'fore', clrLabel, ...
        'back', clrDiv1 ...
    );
    
    % VCO2
    hfp21 = uicontrol( ...                    % Octave
        'style', 'edit', ...
        'parent', hpWf2, ...
        'units', 'pixels', ...
        'position', [125 10+25*2 40 20], ...
        'string', num2str(fp(2, 1)), ...
        'callback', cfp21, ...
        'back', clrTextBack, ...
        'fore', clrTextFore ...
    );
    hfp21Label = uicontrol( ...
        'style', 'text', ...
        'parent', hpWf2, ...
        'units', 'pixels', ...
        'position', [80 5+25*2 40 20], ...
        'string', 'OCT :', ...
        'fore', clrLabel, ...
        'back', clrDiv1 ...
    );

    hfp22 = uicontrol( ...                    % Transpose
        'style', 'edit', ...
        'parent', hpWf2, ...
        'units', 'pixels', ...
        'position', [125 10+25*1 40 20], ...
        'string', num2str(fp(2, 2)), ...
        'callback', cfp22, ...
        'back', clrTextBack, ...
        'fore', clrTextFore ...
    );
    hfp22Label = uicontrol( ...
        'style', 'text', ...
        'parent', hpWf2, ...
        'units', 'pixels', ...
        'position', [80 5+25*1+3 40 25], ...
        'string', 'TRANSPOSE :', ...
        'fore', clrLabel, ...
        'back', clrDiv1 ...
    );

    hfp23 = uicontrol( ...                    % Tune
        'style', 'edit', ...
        'parent', hpWf2, ...
        'units', 'pixels', ...
        'position', [125 10+25*0 40 20], ...
        'string', num2str(fp(2, 3)), ...
        'callback', cfp23, ...
        'back', clrTextBack, ...
        'fore', clrTextFore ...
    );
    hfp23Label = uicontrol( ...
        'style', 'text', ...
        'parent', hpWf2, ...
        'units', 'pixels', ...
        'position', [80 5+25*0 40 20], ...
        'string', 'TUNE :', ...
        'fore', clrLabel, ...
        'back', clrDiv1 ...
    );


%-- Mix Level --%
    
    vlMin = 0;      % Min VCO Mix Level
    vlMax = 1;      % Max VCO Mix Level

    % Callback
    cvlEd = [ ...                            % Editbox
        'vlStr = get(hvlEd, ''string'');' ...      % Get Value
        'vl(2) = str2num(vlStr); ' ...
        'vl(1) = 1 - vl(2); ' ...
        'set(hvlSl,''value'',vl(2));' ...             % Set Slider
    ];
    cvlSl = [ ...                            % Slider
        'vl(2) = get(hvlSl,''value'');' ...           % Get Value
        'vl(1) = 1 - vl(2); ' ...
        'set(hvlEd,''string'',num2str(vl(2)));' ...   % Set Editbox
    ];


    % Make UI
    hvlEd = uicontrol( ...                    % Editbox
        'style', 'edit', ...
        'parent', hpVco, ...
        'units', 'pixels', ...
        'position', [105 105 50 20], ...
        'string', num2str(vl(2)), ...
        'callback', cvlEd, ...
        'back', clrTextBack, ...
        'fore', clrTextFore ...
    );
    hvlSl = uicontrol( ...                    % Slider
        'style', 'slider', ...
        'parent', hpVco, ...
        'units', 'pixels', ...
        'position', [40 85 115 15], ...
        'value', vl(2), ...
        'min', vlMin, ...
        'max', vlMax, ...
        'back', clrSl', ...
        'fore', clrLabel, ...
        'callback', cvlSl ...
    );
    hvlLabel = uicontrol( ...
        'style', 'text', ...
        'parent', hpVco, ...
        'units', 'pixels', ...
        'position', [10 105 90 15], ...
        'string', 'MIX BALANCE :', ...
        'back', clrPanel, ...
        'fore', clrLabel ...
    );
    hvlLabel1 = uicontrol( ...
        'style', 'text', ...
        'parent', hpVco, ...
        'units', 'pixels', ...
        'position', [20 85 15 14], ...
        'string', '1', ...
        'back', clrPanel, ...
        'fore', clrLabel ...
    );
    hvlLabel2 = uicontrol( ...
        'style', 'text', ...
        'parent', hpVco, ...
        'units', 'pixels', ...
        'position', [160 85 15 14], ...
        'string', '2', ...
        'back', clrPanel, ...
        'fore', clrLabel ...
    );


%-- FEG to Pitch --%
    % Panel
    hpFeiVco = uipanel(...
        'parent', hpVco, ...
        'units', 'pixels', ...
        'position', [10 10 175 65], ...
        'back', clrDiv2, ...
        'fore', clrLabel, ...
        'title', 'FILTER EG TO PITCH' ...
    );

    feiVcoMin = 0.0;    % Min fei
    feiVcoMax = 1.0;   % Max fei
    feInvMin = 0.0;     % Min feInv
    feInvMax = 1.0;     % Max feInv

    % Callback
    cfeiVco1Sl = 'fei(1) = get(hfeiVco1Sl,''value'');';   % feiVco Slider
    cfeiVco2Sl = 'fei(2) = get(hfeiVco2Sl,''value'');';
    cfeInvVco1C = 'feInv(1) = get(hfeInvVco1C,''value'');';     % feInv Checkbox
    cfeInvVco2C = 'feInv(2) = get(hfeInvVco2C,''value'');';

    % Make UI
    % VCO1
    hfeiVco1Sl = uicontrol( ...                   % Slider
        'style', 'slider', ...
        'parent', hpFeiVco, ...
        'units', 'pixels', ...
        'position', [25 10+20*1 95 15], ...
        'value', fei(1), ...
        'min', feiVcoMin, ...
        'max', feiVcoMax, ...
        'back', clrSl, ...
        'fore', clrLabel, ...
        'callback', cfeiVco1Sl ...
    );
    hfeiVco1Label = uicontrol( ...
        'style', 'text', ...
        'parent', hpFeiVco, ...
        'units', 'pixels', ...
        'position', [5 10+20*1 20 15], ...
        'string', '1 :', ...
        'back', clrDiv2, ...
        'fore', clrLabel ...
    );

    % VCO2
    hfeiVco2Sl = uicontrol( ...                   % Slider
        'style', 'slider', ...
        'parent', hpFeiVco, ...
        'units', 'pixels', ...
        'position', [25 10+20*0 95 15], ...
        'value', fei(2), ...
        'min', feiVcoMin, ...
        'max', feiVcoMax, ...
        'back', clrSl, ...
        'fore', clrLabel, ...
        'callback', cfeiVco2Sl ...
    );
    hfeiVco2Label = uicontrol( ...
        'style', 'text', ...
        'parent', hpFeiVco, ...
        'units', 'pixels', ...
        'position', [5 10+20*0 20 15], ...
        'string', '2 :', ...
        'back', clrDiv2, ...
        'fore', clrLabel ...
    );
    
    % Inv VCO1
    hfeInvVco1C = uicontrol( ...
        'style', 'checkbox', ...
        'parent', hpFeiVco, ...
        'units', 'pixels', ...
        'position', [125 10+20*1 40 20], ...
        'max', feInvMax, ...
        'min', feInvMin, ...
        'string', 'INV', ...
        'back', clrDiv2, ...
        'fore', clrLabel, ...
        'callback', cfeInvVco1C ...
    );

    % Inv VCO2
    hfeInvVco2C = uicontrol( ...
        'style', 'checkbox', ...
        'parent', hpFeiVco, ...
        'units', 'pixels', ...
        'position', [125 10+20*0 40 20], ...
        'max', feInvMax, ...
        'min', feInvMin, ...
        'string', 'INV', ...
        'back', clrDiv2, ...
        'fore', clrLabel, ...
        'callback', cfeInvVco2C ...
    );

