function y = vcoMix(y1, y2, vl)
%   ----------------------------------------------------------------
%       
%       Title :     MatLead -SYNTHESIZER-
%       
%       Component : VCO Mixer
%       
%       Version :   1.0.1 Web Edition
%       Date :      2008.5.22
%       Author :    XIAORING <http://mkgweb.undo.jp>
%       Copyright : (c) 2008 XIAORING. All rights reserved.
%       
%   ----------------------------------------------------------------
%
%       <Arguments>
%       y1 =    Input Sound Samples (1, tl)
%       y2 =    Input Sound Samples (1, tl)
%       vl =    VCO Mix Level (ratio(0-1) | Vector 1, 2 | col: VCO1, VCO2)
%       
%   ----------------------------------------------------------------


% Mix Level
y1 = y1 * vl(1);
y2 = y2 * vl(2);

% Length
ly1 = length(y1);
ly2 = length(y2);

% Mixing
if ly1 > ly2;
    y = y1;
    y(1 : ly2) = y(1 : ly2) + y2;
else;
    y = y2;
    y(1 : ly1) = y(1 : ly1) + y1;
end;

% Limiting
y = y / max( abs(y) );
