function a = waveform(n, wf)
%   ----------------------------------------------------------------
%       
%       Title :     MatLead -SYNTHESIZER-
%       
%       Component : Waveform Generator
%                   to Make Sound Vector
%       
%       Version :   1.0.1 Web Edition
%       Date :      2008.5.22
%       Author :    XIAORING <http://mkgweb.undo.jp>
%       Copyright : (c) 2008 XIAORING. All rights reserved.
%       
%   ----------------------------------------------------------------
%
%       <Arguments>
%       n =     Harmonics Number (number)
%       wf =    Wave Form
%                   1 : Sine
%                   2 : Saw
%                   3 : Square
%                   4 : Triangle
%                   5 : Ramp
%       
%   ----------------------------------------------------------------

% Default
a = zeros(1, n);

% Sine
if wf == 1
    a(1) = 1;

% Saw
elseif wf == 2
    for i = 1 : n
        a(i) = 1/i;
    end

% Square
elseif wf == 3
    for i = 1 : n
        if rem(i, 2) == 1
            a(i) = 1/i;
        end
    end

% Triangle
elseif wf == 4
    for i = 1 : n
        if rem(i, 2) == 1
            a(i) = (-1)^((i-1)/2) * (1/(i^2));
        end
    end

% Ramp
elseif wf == 5
    for i = 1 : n
        a(i) = -1/i;
    end

end
